package jp.co.sds_corp.hibiya.monitor;

import java.util.HashMap;
import java.util.List;

import jp.co.sds_corp.hibiya.connector.IConnector;
import jp.co.sds_corp.hibiya.server.IChecker;

/**
* グラフのデータを保持します。
*/
public class GraphBufferFactory
{
	static HashMap<String,GraphBuffer>	mapAll = new HashMap<String,GraphBuffer>();

	public static void addBuffer( IConnector con, IChecker chk,
									MonitorParam prm )
	{
		List<GraphParam> list = prm.listGraphParam();
		for ( int i = 0; i < list.size(); i++ ) {
			GraphParam gp = (GraphParam )list.get( i );
			addBuffer( con, chk, gp );
		}
	}

	public static void addBuffer( IConnector con, IChecker chk,
									GraphParam prm )
	{
		String key = con.getName() + ":" + chk.getName() + ":" + prm.getValue();
		GraphBuffer ret = (GraphBuffer )mapAll.get( key );
		if ( ret == null ) {
			ret = new GraphBuffer( con, chk, prm );
			con.addCheckerListener( ret );
			mapAll.put( key, ret );
		}
	}

	public static GraphBuffer getBuffer( IConnector con, IChecker chk,
									GraphParam prm )
	{
		String key = con.getName() + ":" + chk.getName() + ":" + prm.getValue();
		GraphBuffer ret = (GraphBuffer )mapAll.get( key );
		return ret;
	}

}
