package	jp.co.sds_corp.hibiya.monitor;

import java.awt.BorderLayout;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.connector.IConnector;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* {@link IChecker}のグラフを表示します。
*/
public class GraphPanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	Window			owner;
	SetupParam		setup;
	GraphSetupParam	gsu;
	java.util.List<GraphParam>	list;
	ResourceBundle	res;
	JButton			BTN_SETUP;
	Graph			graph;
	GraphSetupDialog	setupDlg;

	IConnector		con;
	MonitorParam	param;
	IChecker		chk;

	public GraphPanel( Window owner, SetupParam setup ) {
		this.owner = owner;
		this.setup = setup;
		createControls();
	}

	protected void createControls() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		String var;

		if ( owner instanceof Dialog ) {
			setupDlg = new GraphSetupDialog( (Dialog )owner, setup );
		} else if ( owner instanceof Frame ) {
			setupDlg = new GraphSetupDialog( (Frame )owner, setup );
		}
		setLayout( new BorderLayout() );

		graph = new Graph();
		add( graph, BorderLayout.CENTER );
		Box box1 = new Box( BoxLayout.X_AXIS );
		box1.add( graph.getLegend() );

		var = res.getString( "graph.setup.text" );
		BTN_SETUP = new JButton( var );
		BTN_SETUP.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				setup();
			}
		});
		box1.add( BTN_SETUP );
		add( box1, BorderLayout.SOUTH );
	}

	protected void setup() {
		WindowUtility.center( this, setupDlg );
		setupDlg.setVisible( true );
		if ( setupDlg.getResult() == 1 ) {
			graph.getLegend().update();
			graph.setParam( gsu, list );
			graph.repaint();
		}
	}

	public void setParam( IConnector con, IChecker chk,
						GraphSetupParam gsu, java.util.List<GraphParam> list )
	{
		this.con = con;
		this.chk = chk;
		this.gsu = gsu;
		this.list = list;
		for ( int i = 0; i < list.size(); i++ ) {
			GraphParam gprm = (GraphParam )list.get( i );
			gprm.setConnector( con );
			gprm.setChecker( chk );
		}
		graph.setParam( gsu, list );
		setupDlg.setParam( con, chk, gsu, list );
	}

}

