package	jp.co.sds_corp.hibiya.monitor;

import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.layout.EventLayout;
import jp.co.sds_corp.hibiya.layout.ILayout;
import jp.co.sds_corp.hibiya.server.CheckerChangeEvent;
import jp.co.sds_corp.hibiya.server.DummyChecker;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link ILayout}を設定するパネルです。
*/
public class LayoutPanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	Window		owner;
	SetupParam	setup;
	ILayout		layout;
	EventLayout	sampleLayout;
	ValuePanel	PNL_FMT;
	JButton		BTN_TEST;
	CheckerChangeEvent	sample;
	ResourceBundle	res;

	public LayoutPanel( Window owner, SetupParam setup ) {
		this.owner = owner;
		this.setup = setup;
		createControls();
	}

	protected void createControls() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		String	text;
		sampleLayout = new EventLayout();
		sample = new CheckerChangeEvent( new DummyChecker(),
			IChecker.Status.OK, IChecker.Status.NG, new Exception( "exception" ),
			"sample message" );

		PNL_FMT = new ValuePanel( ValuePanel.ReturnType.STRING, "Format:" );
		add( PNL_FMT );

		text = res.getString( "layout.test.text" );
		BTN_TEST = new JButton( text );
		BTN_TEST.setMnemonic( KeyEvent.VK_T );
		add( BTN_TEST );
		BTN_TEST.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onTest();
			}
		});
	}

	private void onTest() {
		String fmt = (String )PNL_FMT.getValue();
		if ( fmt.length() == 0 ) {
			return;
		}
		sampleLayout.setFormat( fmt );
		String title = res.getString( "layout.test.title" );
		String res = sampleLayout.format( sample );
		JOptionPane.showMessageDialog( getParent(),
			res, title, JOptionPane.INFORMATION_MESSAGE);
	}

	/**
	* {@link ILayout}を入力された情報で更新します。
	*/
	public void updateLayout() {
		if ( layout != null ) {
			layout.setFormat( (String )PNL_FMT.getValue() );
		}
	}

	/**
	* イベントをフォーマットするILayout(layout)を設定します。
	* @param	var		設定するデータ
	*/
	public void setEventLayout( ILayout var ) {
		this.layout = var ;
		if ( layout == null ) {
			PNL_FMT.setValue( null );
			layout = new EventLayout();
		} else {
			PNL_FMT.setValue( layout.getFormat() );
		}
	}
	/**
	* イベントをフォーマットするILayout(layout)を取得します。
	* @return	layoutの内容
	*/
	public ILayout getEventLayout() {
		if ( ((String )PNL_FMT.getValue()).length() == 0 ) {
			return null;
		}
		return layout;
	}

	public void setEnabled( boolean bEn ) {
		PNL_FMT.setEnabled( bEn );
		BTN_TEST.setEnabled( bEn );
	}

}
