package	jp.co.sds_corp.hibiya.monitor;

import javax.swing.JOptionPane;
import javax.swing.UIManager;

import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.log.CmnLogger;

/**
* Hibiya Monitorを起動するメインクラスです。
*/
public class Monitor
{
	static CmnLogger logger = CmnLogger.getInstance();

	public static void main( String argv[] ) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception exc) {
			System.err.println( "Error loading L&F: " + exc);
		}
		try {
			String file = System.getProperty( "Hibiya.config" );
			if ( file == null ) {
				file = "monitor.xml";
			}
			DOMConfiguration config = new DOMConfiguration( file );

			MonitorDialog dlg = new MonitorDialog();
			dlg.init( config );
			dlg.setVisible( true );
			dlg.toFront();
		} catch ( Throwable ex ) {
			logger.error( ex, "Initialize error.", ex );
			JOptionPane.showMessageDialog( null,
				"Error occurred.\n" + ex,
				"Error",
				JOptionPane.ERROR_MESSAGE );
			System.exit( 9 );
		}
	}
}
