package jp.co.sds_corp.hibiya.monitor.action;

import java.awt.Dimension;
import java.io.File;
import java.util.ResourceBundle;

import javax.swing.BoxLayout;
import javax.swing.border.TitledBorder;

import jp.co.sds_corp.hibiya.action.IAction;
import jp.co.sds_corp.hibiya.action.SoundAction;
import jp.co.sds_corp.util.window.FileSelector;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* 音を鳴らす設定をするPanelです。
*/
public class SoundPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	FileSelector	ap;
	ValuePanel		VAL1;
	ResourceBundle	res;

	public SoundPanel() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		String text;
		text = res.getString( "action.sound.title" );
		setBorder( new TitledBorder( text ));
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));
		ap = new FileSelector( new File( "." ).getAbsolutePath(),
								"Audio", FileSelector.Type.AUDIO );
		add( ap );
		setBorder( new TitledBorder( text ));
		text = res.getString( "action.sound.times.text" );
		VAL1 = new ValuePanel( ValuePanel.ReturnType.INT, text );
		VAL1.setValueSize( new Dimension( 50, 22 ));
		add( VAL1 );
		add( VAL_MINSTAT );
		add( PNL_UNIQ );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		ap.setEnabled( bEn );
		VAL1.setEnabled( bEn );
	}

	public void setAction( IAction action ) {
		super.setAction( action );
		if ( action == null ) {
			clear();
			return;
		}
		SoundAction sa = (SoundAction )action;
		ap.setSelection( sa.getFile() );
		VAL1.setValue( String.valueOf( sa.getTime() ));
	}

	public void clear() {
		super.clear();
		ap.setSelection( null );
		VAL1.setValue( "1" );
	}

	public void updateAction() throws Exception {
		super.updateAction();
		String val = ap.getSelection();
		if ( val == null || val.length() == 0 ) {
			String msg = res.getString( "action.sound.err1.message" );
			throw( new Exception( msg ));
		}
		SoundAction sa = (SoundAction )action;
		sa.setFile( val );
		if ( VAL1.getValue() != null ) {
			sa.setTime( ((Integer )VAL1.getValue()).intValue() );
		}
	}

}

